
Ruby - Bug #18933

Dir.tmpdir implemented in non-Ractor-safe manner

07/21/2022 12:45 PM - kreynolds (Kelley Reynolds)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 3.1.2p20 (2022-04-12 revision

4491bb740a) [x86_64-darwin21]

Backport: 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1:

UNKNOWN

Description

Background

Inside a Ractor, it is expected that generating a temporary directory using Dir.tmpdir will work. The current implementation uses a

number of things which are not considered Rector-safe and will require refactoring.

How to reproduce

Ractor.new { Dir.tmpdir }

 

Expectation and result

The result is expected to be something along the lines of "/var/folders/xm/y4c00x0s26sgf_zlnqjh_7800000gn/T" but instead a

Ractor::IsolationError exception is raised:

3.1.2/lib/ruby/3.1.0/tmpdir.rb:23:in 

`tmpdir': can not access class variables from non-main Ractors (Ractor::IsolationError)

 

Suggested solutions

Make cached class variable a shareable constant

Modify how random values are generated to be Rector-safe

Associated revisions

Revision 3e605a781970cef365002167634a1b5a176bffcb - 07/03/2023 05:47 AM - nobu (Nobuyoshi Nakada)

[ruby/tmpdir] [Bug #18933] Make Dir.mktmpdir Ractor-safe

Fix https://bugs.ruby-lang.org/issues/18933

https://github.com/ruby/tmpdir/commit/446e636434

Revision 3e605a781970cef365002167634a1b5a176bffcb - 07/03/2023 05:47 AM - nobu (Nobuyoshi Nakada)

[ruby/tmpdir] [Bug #18933] Make Dir.mktmpdir Ractor-safe

Fix https://bugs.ruby-lang.org/issues/18933

https://github.com/ruby/tmpdir/commit/446e636434

Revision 3e605a78 - 07/03/2023 05:47 AM - nobu (Nobuyoshi Nakada)

[ruby/tmpdir] [Bug #18933] Make Dir.mktmpdir Ractor-safe

Fix https://bugs.ruby-lang.org/issues/18933

https://github.com/ruby/tmpdir/commit/446e636434

History

#1 - 07/28/2022 11:57 AM - kreynolds (Kelley Reynolds)

- File tmpdir.diff added
Attached is a possible solution for this

#2 - 10/25/2022 02:56 AM - nobu (Nobuyoshi Nakada)

In Ruby 3.0, an instance variable also is not accessible from non-main Ractor.

#3 - 05/14/2023 05:12 AM - headius (Charles Nutter)

Why not just put this in a private constant? I believe that would be Ractor-safe and it would make more sense than a lazy class variable or class

instance variable (that's not actually lazy).

#4 - 06/22/2023 11:02 PM - jeremyevans0 (Jeremy Evans)

@nobu (Nobuyoshi Nakada) submitted a pull request to fix this upstream: https://github.com/ruby/tmpdir/pull/22

#5 - 07/03/2023 05:47 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|3e605a781970cef365002167634a1b5a176bffcb.

[ruby/tmpdir] [Bug #18933] Make Dir.mktmpdir Ractor-safe

Fix https://bugs.ruby-lang.org/issues/18933

https://github.com/ruby/tmpdir/commit/446e636434

Files

tmpdir.diff 1.77 KB 07/28/2022 kreynolds (Kelley Reynolds)
